#import <Cocoa/Cocoa.h>
#import "fluDefs.h"
#import "SIDWin.h"
#import "SIDCommunityWin.h"

@interface USFApp : NSWindowController
{
    IBOutlet  id		_view;
    IBOutlet  id		_legend;
    IBOutlet  id		_scaleradio;
    IBOutlet  id		_initbutton;
    IBOutlet  id		_stepbutton;
    IBOutlet  id		_autocheck;
    IBOutlet  id		_stopbutton;
    IBOutlet  id		_clearbutton;
    IBOutlet  id		_year;
    IBOutlet  id		_deaths;
    IBOutlet  id		_deathsi;
    IBOutlet  id		_deathsm;
    IBOutlet  id		_deathso;
    IBOutlet  id		_deathsc;
    IBOutlet  id		_population;
    IBOutlet  id		_RR;
    IBOutlet  id		_SS;
    IBOutlet  id		_TT;

    IBOutlet  id		_slideri;
    IBOutlet  id		_sliderm;
    IBOutlet  id		_slidero;
    IBOutlet  id		_sliderc;
    IBOutlet  id		_sliderei;
    IBOutlet  id		_sliderec;
    IBOutlet  id		_sliderem;
    IBOutlet  id		_slidereo;

    IBOutlet  id		_efficacyi;
    IBOutlet  id		_efficacyc;
    IBOutlet  id		_efficacyo;
    IBOutlet  id		_efficacym;
    IBOutlet  id		_infant;
    IBOutlet  id		_child;
    IBOutlet  id		_middle;
    IBOutlet  id		_old;
    IBOutlet  id		_beta;
    IBOutlet  id		_beta2;

	IBOutlet  id		_recoveryi;
	IBOutlet  id		_recoveryc;
	IBOutlet  id		_recoverym;
	IBOutlet  id		_recoveryo;
	IBOutlet  id		_mortalityi;
	IBOutlet  id		_mortalityc;
	IBOutlet  id		_mortalitym;
	IBOutlet  id		_mortalityo;
	IBOutlet  id		_travel;
	IBOutlet  id		_silenceitem;

    IBOutlet  id		_x1;
    IBOutlet  id		_x2;
    IBOutlet  id		_x4;
    IBOutlet  id		_x8;
    IBOutlet  id		_x16;

    IBOutlet  id		_FluReport;
    IBOutlet  id		_CasesReport;
    IBOutlet  id		_symbols;

	NSBitmapImageRep	*m_bitsview;
	NSBitmapImageRep	*m_bitsmask;
	NSBitmapImageRep	*m_bitsregion;
	SIDWindow			*m_SID_chart;
	SIDCommunityWindow  *m_SIDComm_chart;
	SIDRec				*m_chart_data;
	SIDCommRec			m_comm_data;
	fModelRec			*m_cases;
    NSTimer				*m_timer;
	BOOL				m_clear;
	BOOL				m_inited;
	int					m_height;
	int					m_width;
	int					m_rowbytes;
	int					m_pixsize;
	int					m_ticks;
	int					m_day;
	int					m_month;
	int					m_year;
	int					m_week;
	int					m_week_ctr;
	int					m_index_comm1;
	int					m_index_comm2;
	int					m_index_comm3;
	int					m_index_comm4;
	int					m_index_comm5;
	int					m_index_comm6;
	float				m_timer_interval;
	float				m_beta1;
	float				m_beta2;
	float				m_infant;
	float				m_middle;
	float				m_child;
	float				m_old;
	float				m_efficacyi;
	float				m_efficacyc;
	float				m_efficacym;
	float				m_efficacyo;
	float				m_recoveri;
	float				m_recoverc;
	float				m_recoverm;
	float				m_recovero;
	float				m_mortalityi;
	float				m_mortalityc;
	float				m_mortalitym;
	float				m_mortalityo;
	float				m_travel;
	float				m_deaths;
	float				m_deathsi;
	float				m_deathsc;
	float				m_deathsm;
	float				m_deathso;
	float				m_infections;
	float				m_all_cases;
	float				m_max_pop;
	float				m_total_s;
	float				m_max_region;
	float				m_R;
	float				m_S;
	float				m_T;
	int					m_array_size;
	int					m_silence;
}

- (void) setCases:(int)isSilent;
- (IBAction)doInitialize:(id)sender;
- (IBAction)doStep:(id)sender;
- (IBAction)doClear:(id)sender;
- (IBAction)doStop:(id)sender;
- (IBAction)doScale:(id)sender;
- (IBAction)doScale2:(id)sender;
- (IBAction)doScale4:(id)sender;
- (IBAction)doScale8:(id)sender;
- (IBAction)doScale16:(id)sender;

- (IBAction)doSlideri:(id)sender;
- (IBAction)doSliderc:(id)sender;
- (IBAction)doSliderm:(id)sender;
- (IBAction)doSlidero:(id)sender;
- (IBAction)doEfficacyI:(id)sender;
- (IBAction)doEfficacyC:(id)sender;
- (IBAction)doEfficacyM:(id)sender;
- (IBAction)doEfficacyO:(id)sender;
- (IBAction)doAutocheck:(id)sender;

- (IBAction)showChart:(id)sender;
- (IBAction)showCommChart:(id)sender;
- (IBAction)doSilence:(id)sender;

// Local:

-(void)getAllVariables;
-(void)addInfectedNeighbors;
-(float)sumOfInfectedNeighbors:(int)x y:(int)y;
-(float)sumOfNeighborsInRow:(fModelRec *)row xPos:(int)xPos includeCurrent:(BOOL)includeCurrent;
-(BOOL)trueRandom:(double)prob;
-(void)scalingChanged:(int)newScale;
-(void)initializePopulation;
-(void)computeCases;
-(void) addCommunity:(SIDRec *)data index:(int)index;
-(void)computeInitialCases;
-(int)maxDays;
-(float) populationProb:(unsigned char)green;
-(void) setFloatStr:(float)val target:(id)target;
-(void) computeMaxRegion:(int *)regions;

@end
