#import <Cocoa/Cocoa.h>
#import "fludefs.h"

@interface USFImageView : NSImageView
{    
    NSBitmapImageRep		*m_bitmap;		// The bitmap display
	NSRect					m_frame;		// Original frame
	id						m_app;			// The main app.
    int						m_ID;			// ID value
    BOOL					m_is_source;		// I am the source image transfer
    BOOL					m_drag_over;		// Dragging image to top
	BOOL					m_busy;
	int						m_red;
	int						m_orange;
	int						m_black;
	int						m_scale;
}

-(void) setMainApp:(id)app;
- (void) initNewBitmap:(NSBitmapImageRep *)rep cases:(fModelRec *)cases mask:(NSBitmapImageRep *)mask maxPop:(float)maxPop;
- (NSBitmapImageRep *) bitmap;
- (void)bitmapChanged;
-(int)redCount;
-(int)orangeCount;
-(int)blackCount;
-(void)setScale:(int)scale fromPt:(NSPoint *)fromPt;
-(NSPoint)adjustScaling:(int)newScale fromPt:(NSPoint *)fromPt;

@end
