
#define MAX_GREEN			245
#define NULL_REGION			0
#define MAX_WEEK		    52

// Community co-ordinates

#define COMMUNITY1_ROW		514
#define COMMUNITY1_COL		1338

#define COMMUNITY2_ROW		552
#define COMMUNITY2_COL		976

#define COMMUNITY3_ROW		806
#define COMMUNITY3_COL		168

#define COMMUNITY4_ROW		338
#define COMMUNITY4_COL		120

#define COMMUNITY5_ROW		608
#define COMMUNITY5_COL		524

#define COMMUNITY6_ROW		1083
#define COMMUNITY6_COL		1252


typedef struct {
	int				*region; // The region (nil = none)
	float			si;		// Susceptible infant
	float			sc;		// Susceptible child
	float			sm;		// Susceptible middle
	float			so;		// Susceptible older
	float			ii;		// Infected infent
	float			ic;		// Infected child
	float			im;		// Infected middle
	float			io;		// Infected older
	float			ri;		// Recovered infant
	float			rc;		// Recovered child
	float			rm;		// Recovered middle
	float			ro;		// Recovered old
	float			d;		// Dead
	float			iP;		// Sum of all infected neighbors
} fModelRec;

typedef struct {
	float			s;		// Susceptibles
	float			i;		// Infecteds
	float			d;		// Deaths
} SIDRec;

typedef struct {
	SIDRec	*		region1;
	SIDRec	*		region2;
	SIDRec	*		region3;
	SIDRec	*		region4;
	SIDRec	*		region5;
	SIDRec	*		region6;
} SIDCommRec;
